;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;             
;                                                  ;             
;   sse1_dw2hex: converts a dword-value to an      ;             
;                ASC-hex-string                    ;             
;                preceding zeros are skiped        ;             
;                e.g.: "1A"                        ;             
;                                                  ;             
;       eax = dwValue                              ;             
;       edx = lpBuffer , should be aligned to 8    ;             
;                                                  ;             
;       return:  eax = pointer to string in buffer ;             
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;             
align 16                                                         
sse1_dw2hex proc ;var:DWORD,buffer:DWORD                         
                                                                 
    .data                                                        
        align 16                                                 
        d2h_bitmsk  dw 4 dup (0f00fh)                            
        d2h_cmpmsk  db 8 dup (9)                                 
        d2h_09_msk  db 8 dup (030h)                              
        d2h_AF_msk  db 8 dup (7)                                 
    .code                                                        
                                                                 
                                                                 
    movq mm4,QWORD ptr [d2h_bitmsk]                              
    movq mm5,QWORD ptr [d2h_cmpmsk]                              
    movq mm6,QWORD ptr [d2h_09_msk]                              
    movq mm7,QWORD ptr [d2h_AF_msk]                              
                                                                 
    movd mm1,eax                                                 
    punpcklbw mm1,mm1                                            
    pshufw mm1,mm1,000011011y                                    
                                                                 
    pand mm1,mm4                                                 
    movq mm0,mm1                                                 
    psrlw mm0,12                                                 
    psllw mm1,8                                                  
                                                                 
    por mm0,mm1                                                  
    movq mm2,mm0                                                 
    pcmpgtb mm2,mm5                                              
                                                                 
    pand mm2,mm7                                                 
    paddb mm2,mm6                                                
    paddb mm2,mm0                                                
                                                                 
                                                                 
    movq QWORD ptr [edx],mm2                                     
    mov BYTE ptr [edx+8],0                                       
                                                                 
    pcmpeqb mm2,mm6                                              
    pmovmskb eax,mm2                                             
    not eax                                                      
    bsf eax,eax                                                  
                                                                 
    test eax,8                                                   
    .if !ZERO?                                                   
        dec eax                                                  
    .endif                                                       
    add eax,edx                                                  
                                                                 
    ret                                                          
sse1_dw2hex endp                                                 
                                                                 
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;             
;                                                  ;             
;   sse1_dw2hexView: converts a dword-value to an  ;             
;                ASC-hex-string                    ;             
;                eg.: "00001FFA"                   ;             
;                                                  ;             
;       eax = dwValue                              ;             
;       edx = lpBuffer , should be aligned to 8    ;             
;                                                  ;             
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;             
align 16                                                         
sse1_dw2hexView proc ;var:DWORD,buffer:DWORD                     
                                                                 
    .data                                                        
        align 16                                                 
        d2hv_bitmsk dw 4 dup (0f00fh)                            
        d2hv_cmpmsk db 8 dup (9)                                 
        d2hv_09_msk db 8 dup (030h)                              
        d2hv_AF_msk db 8 dup (7)                                 
    .code                                                        
                                                                 
    ;bswap eax                           ;<== insert for mmx only
    movq mm4,QWORD ptr [d2hv_bitmsk]     ;       |               
    movq mm5,QWORD ptr [d2hv_cmpmsk]     ;       |               
    movq mm6,QWORD ptr [d2hv_09_msk]     ;       |               
    movq mm7,QWORD ptr [d2hv_AF_msk]     ;       |               
                                         ;       |               
    movd mm1,eax                         ;       |               
    punpcklbw mm1,mm1                    ;       V               
    pshufw mm1,mm1,000011011y            ;<== delete for mmx only
                                                                 
    pand mm1,mm4                                                 
    movq mm0,mm1                                                 
    psrlw mm0,12                                                 
    psllw mm1,8                                                  
                                                                 
    por mm0,mm1                                                  
    movq mm2,mm0                                                 
    pcmpgtb mm2,mm5                                              
                                                                 
                                                                 
    pand mm2,mm7                                                 
    paddb mm2,mm6                                                
    paddb mm2,mm0                                                
                                                                 
    movq QWORD ptr [edx],mm2                                     
    mov BYTE ptr [edx+8],0                                       
                                                                 
    ret                                                          
sse1_dw2hexView endp                                             
